<!DOCTYPE html>
<html>
<head>
    <title>Details</title>
    <style>
        th, td, p, input {
            font:14px Verdana;
        }
        table, th, td
        {
            border: solid 1px #DDD;
            border-collapse: collapse;
            padding: 2px 3px;
            text-align: center;
        }
        th {
            font-weight:bold;
        }
    </style>
</head>
<body>
<p id="showData"></p>
</body>
<script>
    var url='http://localhost:5000/';
    function processForm()
    {
        var parameters = location.search.substring(1).split("&");
        var temp = parameters[0].split("=");
        l = unescape(temp[1]);
        if(l==1)
        {
            showAllTransactions();
        }else if(l==2){
            showIssues();
        }
        else if(l==3){
            showPush();
        }
        else if(l==4){
            showPull();
        }
        else if(l==5){
            showCommits();
        }
    }
    processForm();

    function showAllTransactions()
    {
        const Http = new XMLHttpRequest();
        Http.open("GET", url+'monitorAll/', true);
        Http.setRequestHeader("contentType","application/json");
        Http.send();
        Http.onreadystatechange = (e) => {
            if (Http.status == 200 && Http.readyState==4) {
                let response = Http.responseText;
                const data = JSON.parse(response);
                var divContainer = document.getElementById("showData");
                divContainer.innerHTML = "";
                divContainer.appendChild(CreateTableFromJSON(data));
            }
        }
    }

    function showIssues()
    {
        const Http = new XMLHttpRequest();
        Http.open("GET", url+'monitorIssues/262132990', true);
        Http.setRequestHeader("contentType","application/json");
        Http.send();
        Http.onreadystatechange = (e) => {
            if (Http.status == 200 && Http.readyState==4) {

                let response = Http.responseText;
                const data = JSON.parse(response);
                var divContainer = document.getElementById("showData");
                divContainer.innerHTML = "";
                divContainer.appendChild(CreateTableFromJSON(data));
            }
        }
    }

    function showPush()
    {
        const Http = new XMLHttpRequest();
        Http.open("GET", url+'monitorPush/262132990', true);
        Http.setRequestHeader("contentType","application/json");
        Http.send();
        Http.onreadystatechange = (e) => {
            if (Http.status == 200 && Http.readyState==4) {

                let response = Http.responseText;
                const data = JSON.parse(response);
                var divContainer = document.getElementById("showData");
                divContainer.innerHTML = "";
                divContainer.appendChild(CreateTableFromJSON(data));
            }
        }
    }

    function showPull()
    {
        const Http = new XMLHttpRequest();
        Http.open("GET", url+'monitorPullRequests/262132990', true);
        Http.setRequestHeader("contentType","application/json");
        Http.send();
        Http.onreadystatechange = (e) => {
            if (Http.status == 200 && Http.readyState==4) {

                let response = Http.responseText;
                const data = JSON.parse(response);
                var divContainer = document.getElementById("showData");
                divContainer.innerHTML = "";
                divContainer.appendChild(CreateTableFromJSON(data));
            }
        }
    }

    function showCommits()
    {
        const Http = new XMLHttpRequest();
        Http.open("GET", url+'monitorCommits/262132990', true);
        Http.setRequestHeader("contentType","application/json");
        Http.send();
        Http.onreadystatechange = (e) => {
            if (Http.status == 200 && Http.readyState==4) {

                let response = Http.responseText;
                const data = JSON.parse(response);
                var divContainer = document.getElementById("showData");
                divContainer.innerHTML = "";
                divContainer.appendChild(CreateTableFromJSON(data));
            }
        }
    }


    function CreateTableFromJSON(datajson) {

               // EXTRACT VALUE FOR HTML HEADER.
        var col = [];
        for (var i = 0; i < datajson.length; i++) {
            for (var key in datajson[i]) {
                if (col.indexOf(key) === -1) {
                    col.push(key);
                }
            }
        }

        // CREATE DYNAMIC TABLE.
        var table = document.createElement("table");

        // CREATE HTML TABLE HEADER ROW USING THE EXTRACTED HEADERS ABOVE.

        var tr = table.insertRow(-1);                   // TABLE ROW.

        for (var i = 0; i < col.length; i++) {
            var th = document.createElement("th");      // TABLE HEADER.
            th.innerHTML = col[i];
            tr.appendChild(th);
        }

        // ADD JSON DATA TO THE TABLE AS ROWS.
        for (var i = 0; i < datajson.length; i++) {

            tr = table.insertRow(-1);

            for (var j = 0; j < col.length; j++) {
                var tabCell = tr.insertCell(-1);
                tabCell.innerHTML = datajson[i][col[j]];
            }
        }
        return table;
    }
</script>
</html>